/*
 Beispielprogramm zum auslesen eines TMP121 oder TMP123 Temperatursensors 
 von Texas Instruments über die SPI Schnittstelle.
 Der Sensor ist read-only.
 Programm ist nicht für negative Temperaturen ausgelegt.
 by <http://www.hjhac.com>
 This example code is public domain.

 Circuit:
 SCK: pin 13
 MISO = SO : pin 12
 SS = CS : pin 10
 */


const int ss = 10; // CS auf Pin 10 legen
#include <SPI.h>

byte byte1; 
byte byte2;
word longbb;
float rTemp;

void setup() {
  Serial.begin(9600);


  SPI.begin();
  SPI.setBitOrder(MSBFIRST);
  pinMode(ss, OUTPUT);
}


void loop() { // Hauptschleife
      read_tmp();
    }

void read_tmp()
{
  Serial.println("Start der Schleife");
  digitalWrite(ss, HIGH); // schaltet den Sensor auf Messen
  delay(1500);            // braucht min 250ms für einen Messdurchgang (350ms max.)
  digitalWrite(ss, LOW);  // schaltet den Sensor auf Ausgabe der Temperatur
  
       // Auslesen der vom Sensor gesendeten 16 bit

  byte1 = SPI.transfer(0x00);           // liest die ersten 8 bit
  byte2 = SPI.transfer(0x00);           // liest die zweiten 8 bit
  word longbb = ((byte1 << 8) + byte2); // verschiebt byte1 um 8 bit und addiert beide zu einen 16 bit Word 
 
        // print der Zwischenwerte in Binär und Hexadezimal
        
     Serial.println(byte1, BIN);
     Serial.println(byte2, BIN);
     Serial.println(byte1, HEX);
     Serial.println(byte2, HEX);
     Serial.println(longbb, BIN);
     Serial.println(longbb, HEX);
     Serial.println();
    Serial.println();
  float rTemp = (float)longbb / 128.0; // der Sensorwert muss durch 128 dividiert werden für °C
  Serial.print("Temp[C]=");
  Serial.print(rTemp);                // Ausgabe der Temperatur in Grad Celsius
     Serial.println();
     Serial.println("end");
     Serial.println();
}
